class9 bash编程基础(一)

一、编程基础

程序:指令+ 数据

程序编程风格:

过程式:以指令为中心,数据服务于指令
对象式:以数据为中心,指令服务于数据

shell 程序:提供了编程能力,解释执行

程序的执行方式

计算机:运行二进制指令;

编程语言: 低级:汇编 高级:

编译:高级语言--> 编译器--> 目标代码
        java,C#解释:高级语言--> 解释器--> 机器代码
     shell, perl, python

编程基本概念

编程逻辑处理方式:

    顺序执行
    循环执行
    选择执行


shell 编程:过程式、解释执行

  编程语言的基本结构:

        数据存储:变量、数组
        表达式: a + b
        语句:if

编程程序语言分类

强类型:定义变量时必须指定类型、参与运算必须符合类型
 要求;调用未声明变量会产生错误
   如 java,python
弱类型:无须指定类型,默认均为字符型;参与运算会自动 进行隐式类型转换;变量无须事先定义可直接调用
   如:bash  不支持浮点数


变量命名法则:1 、不能使程序中的保留字:例如if, for;2、只能使用数字、字母及下划线,且不能以数字开头3 、见名知 义4 、统一命名 规则:驼峰命名法 
     (每个单词字母大写) 大驼峰   StudentName
     (除第一个单词其余单词首字母大写)小驼峰   studentName

二、shell 脚本基础

shell脚本是包含一些命令或声明,并符合一定格式的文本文件

格式要求:首行shebang 机制

#!/bin/bash#!/usr/bin/python#!/usr/bin/perl

shell 脚本的用途有:

自动化常用命令
执行系统管理和故障排除
创建简单的应用程序
处理文本或文件

创建shell 脚本

第一步:使用文本编辑器来创建文本文件

第一行必须包括shell 声明序列:#!
    #!/bin/bash添加注释
   注释以# 开头

第二步:运行脚本

给予执行权限,在命令行上指定脚本的绝对或相对路径


直接运行解释器,将脚本作为解释器程序的参数运行

shell 脚本范例

#!/bin/bash#author: wang
#Version: 1.0
#Description:This script displays some informationabout your
# environmentecho "Greetings. The date and time are $(date)"echo "Your working directory is: $(pwd)"

脚本调试

bash -n /path/to/some_script
       检测脚本中的语法错误
       
bash -x /path/to/some_script
        调试执行


三、变量

变量:命名的内存空间

   数据存储方式:
       字符:
        数值:整型,浮点型
        
变量:变量类型

        作用:        
            1 、数据存储格式        
            2 、参与的运算        
            3 、表示的数据范围
         类型:
        字符
        数值:整型、浮点型

bash 中变量的种类

根据变量的生效范围等标准:
    
    本地变量:生效范围为==当前shell进程==;对当前shell 之外的其它shell 进程,包括当前shell 的子shell 进程均无效
    环境变量:生效范围为当前shell 进程及其子进程
    局部变量:生效范围为当前shell 进程中某代码片断(通常指函数)
    位置变量:$1, $2, ...来表示,用于让脚本在脚本代码中调用通过命令行传递给它的参数
    特殊变量:$?, $0, $*, $@, $#

本地变量

变量赋值:name=‘value’, 
可以使用引用value:
(1)  可以是直接字串; name=“root"
(2)  变量引用:name="$USER"
(3)  命令引用:name=` COMMAND `, name =$(COMMAND)

变量引用:${name}, $name"" :弱引用,其中的变量引用会被替换为变量值'':强引用,其中的变量引用不会被替换为变量值,而保持原字符串

显示已定义的所有变量:set删除变量:unset name

环境变量

变量声明、赋值:
    export name=VALUE    declare -x name=VALUE
    变量引用:$name, ${name}
[root@6 bin]# a=1
[root@6 bin]# b=2
[root@6 bin]# ab=34
[root@6 bin]# echo $ab
34
[root@6 bin]# echo ${a}b
1b
显示所有环境变量: 
   
    export     printenv      变量相同
    env
    
    
删除:unset namebash有许多内建的环境变量:PATH, SHELL, USRE,UID,HISTSIZE, HOME, PWD, OLDPWD, HISTFILE, PS1
[root@7 ~]# export num=123
[root@7 ~]# echo $[$num+123]
246
[root@7 ~]# declare -x num2=123
[root@7 ~]# echo $[$num+$num2]
246

只读和位置变量

只读变量:只能声时,但不能修改和删除   
     readonly name    declare -r name     定义常量
     declare -xr  name 环境常量
   [root@6 bin]# readonly num=1
   [root@6 bin]# num=2
    -bash: num: readonly variable
   [root@6 bin]# unset num
    -bash: unset: num: cannot unset: readonly variable
           
位置变量:在脚本代码中调用通过命令行传递给脚本的参数    
        $1, $2, ... :对应第1 、第2 等参数,    
         shift [n] 换位置    $0:  命令本身
         
    $*: 传递给脚本的所有参数,全部参数合为一个字符串    
    $@: 传递给脚本的所有参数,每个参数为独立字符串   
    $#:  传递给脚本的参数的个数       
    $@ $*  ==只在被双引号包起来的时候才会有差异==
        
示例:判断给出的文件的行数
    linecount="$(wc -l $1| cut -d' ' -f1)"
    echo "$1 has $linecount lines."


四、算术运算

bash 中的算术运算:help let
    +, -, *, /, % 取模(取余), ** (乘方)
 实现算术运算:
    (1) let var= 算术表达式
    (2) var=$[ 算术表达式]
    (3) var=$(( 算术表达式))
    (4) var=$(expr arg1 arg2 arg3 ...)
    
          expr 0 + x    判断x是否为整数
          expr 1 \* 2    1*2   *需要转义字符
          
    (5) declare –i var =  数值
    (6) echo ‘ 算术表达式’ | bc
乘法符号有些场景中需要转义 ,如 如*

bash 有内建的随机数生成器:$RANDOM (1-32767) )
     echo $[$RANDOM%50]  :0-49 之间随机数

赋值

增强型赋值:
     +=, -=, *=, /=, %=  let varOPERvalue
       例如:let count+=3
       自加3 后自赋值
  自增,自减:        let var+=1
        let var++        let var-=1
        let var--
[root@6 bin]# a=10
[root@6 bin]# b=10
[root@6 bin]# let c=a++
[root@6 bin]# let d=++b
[root@6 bin]# echo $c $d
10 11

逻辑运算

true, false
  1, 0与:    1 与 与 1 = 1
    1 与 与 0 = 0
    0 与 与 1 = 0
    0 与 与 0 = 0
    或:    1 或 或 1 = 1
    1 或 或 0 = 1
    0 或 或 1 = 1
    0 或 或 0 = 0

逻辑运算

非:!
        ! 1 = 0
        ! 0 = 1短路运算:
    短路与:
        第一个为0 ,结果必定为0; ;
        第一个为1 ,第二个必须要参与运算;
    短路或 :
        第一个为1 ,结果必定为1; ;
        第一个为0 ,第二个必须要参与运算;
    
异或:^
    异或的两个值, 相同为假,不同为真

聚集命令

有两种聚集命令的方法:
    • 复合式:date; who | wc -l
    命令会一个接一个地运行
    
    • 子shell :(date; who | wc -l ) >>/tmp/trace
    所有的输出都被发送给单个STDOUT 和STDERR

五、脚本状态

退出状态

进程使用退出状态来报告成功或失败
    • 0 代表成功,1 -255 代表失败
    • $?  变量保存最近的命令退出状态
    
例如:    $ ping -c1 -W1 hostdown &> /dev/null
    $ echo $?

退出状态码

bash 自定义退出状态码exit [n] :自定义退出状态码;
    子shell中存在错误退出,也可返回状态码 
注意:脚本中一旦遇到exit命令,脚本会立即终止;终止退出状态取决于exit 命令后面的数字

注意:如果未给脚本指定退出状态码,整个脚本的退出状态码

取决于脚本中执行的最后一条命令的状态码

条件测试

判断某需求是否满足,需要由测试机制来实现;
专用的测试表达式需要由测试命令辅助完成测试过程;

评估布尔声明,以便用在条件性执行中
• 若真,则返回0• 若假,则返回1测试命令:
    • test EXPRESSION
    • [ EXPRESSION ]
    • [[ EXPRESSION ]]
    注意:EXPRESSION 前后必须有空白字符

条件性的执行操作符

根据退出状态而定,命令可以有条件地运行
    • &&  代表条件性的AND THEN
    • || 代表条件性的OR ELSE例如:
    $ grep -q no_such_user /etc/passwd \
    || echo 'No such user'
    No such user
    $ ping -c1 -W2 station1 &> /dev/null \
    > && echo "station1 is up" \
    > || (echo 'station1 is unreachable'; exit 1)
    station1 is up

test 命令

长格式的例子:
$ test "$A" == "$B" && echo "Strings are equal"$ test “$A” -eq “$B” \&& echo "Integers are equal"简写格式的例子:
$ [ "$A" == "$B" ] && echo "Strings are equal"$ [ "$A" -eq "$B" ] && echo "Integers are equal"

bash 的测试类型

数值测试:
    -gt:  是否大于;   
    -ge:  是否大于等于;    
    -eq:  是否等于;   
    -ne:  是否不等于;  
    -lt:  是否小于;   
    -le:  是否小于等于;

bash 的测试类型

字符串测试:
== :是否等于;>: ascii 码是否大于ascii码 码
<:  是否小于
!=:  是否不等于=~:  左侧字符串是否能够被右侧的PATTERN所匹配
注意:  此表达式一般用于[[ ]] 中;

-z "STRING":字符串是否为空,空为真,不空为假
-n "STRING":字符串是否不空,不空为真,空为假

注意:用于字符串比较时的用到的操作数都应该使用引号
[root@6 bin]# [[ abc =~ * ]]
[root@6 bin]# echo $?
2
[root@6 bin]# [[ abc =~ .* ]]
[root@6 bin]# echo $?
0
[root@6 bin]# [[ abc =~ a.. ]]
[root@6 bin]# echo $?
0

文件测试

存在性测试
-a FILE :同-e
-e FILE: 文件存在性测试,存在为真,否则为假;存在性及类别测试
-b FILE :是否存在且为块设备文件;
-c FILE :是否存在且为字符设备文件;
-d FILE :是否存在且为目录文件;
-f FILE :是否存在且为普通文件;
-h FILE  或 -L FILE :存在且为符号链接文件;
-p FILE :是否存在且为命名管道文件;
-S FILE :是否存在且为套接字文件;

文件权限测试:

-r FILE :是否存在且可读 
-w FILE:  是否存在且可写
-x FILE:  是否存在且可执行
[root@6 ~]# [ -r a ]
[root@6 ~]# echo $?
0
[root@6 ~]# [ -w a ]
[root@6 ~]# echo $?
0
[root@6 ~]# [ -rw a ]
-bash: [: -rw: unary operator expected
[root@6 ~]# test -rw a
-bash: test: -rw: unary operator expected
[root@6 ~]# test -w a
[root@6 ~]# echo $?
0

文件特殊权限测试:

-g FILE :是否存在且拥有sgid 权限;
-u FILE :是否存在且拥有suid 权限;
-k FILE :是否存在且拥有sticky 权限;

文件大小测试:

-s FILE:  是否存在且非空;

文件是否打开:

-t fd: fd表示文件描述符是否已经打开且与某终端相关
-N FILE:文件自动上一次被读取之后是否被修改过-O FILE :当前有效用户是否为文件属主
-G FILE :当前有效用户是否为文件属组

双目测试:

FILE1 -ef FILE2: FILE1与FILE2 是否指向同一个设
备上的相同inode
FILE1 -nt FILE2: FILE1 是否新于FILE2; 
FILE1 -ot FILE2: FILE1 是否旧于FILE2;

组合测试条件

第一种方式:

COMMAND1 && COMMAND2  并且
COMMAND1 || COMMAND2  或者
! COMMAND 非 

 如:[ -e FILE ] && [ -r FILE ]

第二种方式:

EXPRESSION1 -a EXPRESSION2  并且
EXPRESSION1 -o EXPRESSION2  或者
! EXPRESSION
必须使用测试命令进行;
# [ -z “$HOSTNAME” -o $HOSTNAME "==\    "localhost.localdomain" ] && hostname www.magedu.com# [ -f /bin/cat -a -x /bin/cat ] && cat /etc/fstab

bash位置变量参数

   前面讲过位置参数变量实际是属于系统预定义变量的一种,同样不能修改变量名,作用也是固定的,也不能新增变量。只能修改变量的值。

   我们来看看下面常用的位置参数变量。

     1、$n:n代表数字,$0代表命令本身,$1-$9代表第一到第九个参数,十以上的参数需要用大括号括起来,比如${11}.

     2、$*:这个变量代表命令行中所有的参数,$*把所有的参数看成一个整体。

     3、$@:这个变量也代表命令行中所有的参数,不过$@把每个参数区分对待。

     4、$#:这个变量代表命令行中所有参数的个数。

[root@6 ~]# /root/a.sh 1 2 3 4
4
数值=3
输入的参数=1 2 3 4
输入的参数=1 2 3 4
#! /bin/bash
echo "$#"
num=$[$1+$2]
echo "数值=$num"
echo "输入的参数=$*"
echo "输入的参数=$@"

     5、$@与 $*的区别

       他们的区别就是$*会把所有变量看成一个整体。

       $@会把传给他的所有变量分开来看待,

       通过一个脚本test.sh来说明,

[root@6 ~]# vim test.sh
#!/bin/bash
  a=1
  b=1
 for x in  "$*"
#$*会把传给他的每个参数看成是一个整体,所以只会循环一次
  do
     do
       echo "The parameters $a is :$x"
     a=$(($a+1))
     done
 for y in "$@"
#$@会把传给他的每个参数都看成是独立的,所以”$@”中有几个参数,就会循环几次。
  do
    echo “The parameters $b is: $y”
     b=$(($b+1))
  done
[root@6 ~]# /root/test.sh  1 2 3 4
The parameters 1 is :1 2 3 4
The parameters 1 is: 1
The parameters 2 is: 2
The parameters 3 is: 3
The parameters 4 is: 4

        

一、作业:

1、编写脚本/root/bin/systeminfo.sh,显示当前主机系统信息,包括主机名,IPv4地址,操作系统版本,内核版本,CPU型号,内存大小,硬盘大小。

[root@6 bin]# /root/bin/systeminfo.sh
主机名:6.localdomain
IPV4地址:  10.1.252.177
操作系统版本:CentOS release 6.8 (Final)
内核版本:2.6.32-642.el6.x86_64
CPU型号: Intel(R) Core(TM) i5-3230M CPU @ 2.60GHz
内存容量:1004136 kB
硬盘大小: 128.8 GB
#! /bin/bash
#,显示当前主机系统信息,包括主机名,IPv4地址,操作系统版本,内核版本,CPU型号,内存大小,硬盘
大小
echo "主机名:`hostname`"
echo "IPV4地址: `ip addr|sed -nr '/inet.*brd/p'|sed -r 's@inet\ +(.*)/.*@\1@'|tr -s ' '`"
echo "操作系统版本:`cat /etc/centos-release`"
echo "内核版本:`uname -r`"
echo "CPU型号: `lscpu|sed -nr '/Model\ name/p'|sed -r 's/^.*\ +(In.*$)/\1/'`"
echo "内存容量:` cat /proc/meminfo|sed -nr 's/MemTotal\:\ +(.*$)/\1/p'`"
echo "硬盘大小:`fdisk -l|sed -rn 's/Di.*:(.*)\,.*/\1/p'`"

2、编写脚本/root/bin/backup.sh,可实现每日将/etc/目录备份到/root/etcYYYY-mm-dd中

[root@6 bin]# /root/bin/backup.sh
It is successful.
[root@6 bin]# ls /root
anaconda-ks.cfg  checkdisk.sh   install.log         公共的  图片  音乐
bin              etc2016-08-11  install.log.syslog  模板    文档  桌面
cat              etc2016-08-12  sumid.sh            视频    下载
#! /bin/bash
#/etc/目录备份到/root/etcYYYY-mm-dd中
cp -a /etc /root/etc`date +%F`
if [ $? -eq 0 ];then
 echo "It is successful."
else echo "ERROR."
fi

3、编写脚本/root/bin/disk.sh,显示当前硬盘分区中空间利用率最大的值

[root@6 bin]# /root/bin/disk.sh
The max-disk useage is 19
#! /bin/bash
#显示当前硬盘分区中空间利用率最大的值
useage=$(df|sed -nr '/.*sd/p'|sed -nr 's/.*\ +([0-9]+)%.*/\1/p'|sort -unr |head -1)
echo "The max-disk useage is $useage "

4、编写脚本/root/bin/links.sh,显示正连接本主机的每个远程主机的IPv4地址和连接数,并按连接数从大到小排序

[root@6 bin]# /root/bin/links.sh
远程主机连接数和地址:      2 10.1.250.77
#! /bin/bash
#显示正连接本主机的每个远程主机的IPv4地址和连接数,并按连接数从大到小排序
links=$(netstat -nt|sed -nr '/tcp.*/p'|tr -s ' ' ':'|cut -d: -f6|sort -nr|uniq -c)
echo "远程主机连接数和地址:$links"
unset links

5、写一个脚本/root/bin/sumid.sh,计算/etc/passwd文件中的第10个用户和第20用户的ID之和

[root@6 bin]# /root/bin/sumid.sh
/etc/passwd文件中的第10个用户和第20用户的ID之和=180
#! /bin/bash
#计算/etc/passwd文件中的第10个用户和第20用户的ID之和
uid10=$(sed -n '10p' /etc/passwd|cut -d: -f3)
uid20=$(sed -n '20p' /etc/passwd|cut -d: -f3)
sumid=$[$uid10+$uid20]
echo "/etc/passwd文件中的第10个用户和第20用户的ID之和=$sumid"
unset uid10
unset uid20

6、写一个脚本/root/bin/sumspace.sh,传递两个文件路径作为参数给脚本,计算这两个文件中所有空白行之和

[root@6 bin]# /root/bin/sumspace.sh /root/a  /root/b
两个文件中所有空白行之和=7
#! /bin/bash
#计算这两个文件中所有空白行之和
File1=$(grep '^$' $1|wc -l)
File2=$(grep '^$' $2|wc -l)
FilesSpace=$(($File1+$File2))
echo "两个文件中所有空白行之和=$FilesSpace"
unset File1
unset File2
unset FilesSpace

7、写一个脚本/root/bin/sumfile.sh,统计/etc, /var, /usr目录中共有多少个一级子目录和文件

[root@6 bin]# /root/bin/sumfile.sh
/etc, /var, /usr目录中共有290个一级子目录和文件.
#! /bin/bash
#统计/etc, /var, /usr目录中共有多少个一级子目录和文件
etc=$[$(ls -lA /etc|wc -l)-1]
var=$[$(ls -lA /var|wc -l)-1]
usr=$[$(ls -lA /usr|wc -l)-1]
Files=$(($etc+$var+$usr))
echo "/etc, /var, /usr目录中共有$Files个一级子目录和文件."
unset ect
unset var
unset usr

8、写一个脚本/root/bin/argsnum.sh,接受一个文件路径作为参数;如果参数个数小于1,则提示用户“至少应该给一个参数”,并立即退出;如果参数个数不小于1,则显示第一个参数所指向的文件中的空白行数

[root@6 bin]# /root/bin/argsnum.sh /root/a root/b
第一个文件中的空白行数=3.
[root@6 bin]# /root/bin/argsnum.sh /root/b root/a
第一个文件中的空白行数=4.
[root@6 bin]# /root/bin/argsnum.sh /root/b
第一个文件中的空白行数=4.
[root@6 bin]# /root/bin/argsnum.sh
至少应该给一个参数
#! /bin/bash
#接受一个文件路径作为参数;如果参数个数小于1,则提示用户“至少应该给一个参数”,并立即退出;>
如果参数个数不小于1,则显示第一个参数所指向的文件中的空白行数
[ $# -le 1 ] &&[ $# -ne 1 ]&& echo "至少应该给一个参数" && exit||spaceline=$( grep '^$' $1 |w
c -l )
echo "第一个文件中的空白行数=$spaceline."

9、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

[root@6 bin]# /root/bin/hostping.sh 10.1.252.180
该IP地址可访问.
[root@6 bin]# /root/bin/hostping.sh 10.1.252.167
该IP地址不可访问.
#! /bin/bash
#接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”
ping -c1 -w1 $1 &> /dev/null && echo "该IP地址可访问."||echo "该IP地址不可访问."

10、chmod -rw /tmp/file1,编写脚本/root/bin/per.sh,判断当前用户对/tmp/fiile1文件是否不可读且不可写

[lvasu@6 tmp]$ chmod a-rw file1
[lvasu@6 tmp]$ /tmp/per.sh
文件不可读且不可写.
[lvasu@6 tmp]$ /tmp/per.sh
文件可读且可写.
[root@6 ~]# chmod a+rw /tmp/file1     #权限判断以实际权限为准,即使取消root权限,但是root用户仍然有权限
[root@6 bin]# /root/bin/per.sh
文件可读且可写.
[root@6 ~]# chmod a-rw /tmp/file1
[root@6 bin]# /root/bin/per.sh
文件可读且可写.
#! /bin/bash
#判断当前用户对/tmp/fiile1文件是否不可读且不可写
[ -r /tmp/file1  -a -w /tmp/file1 ]
[ $? -eq 0 ] && echo "文件可读且可写." || echo "文件不可读且不可写."
#! /bin/bash
#判断当前用户对/tmp/fiile1文件是否不可读且不可写
[ ! -r /tmp/file1  -a ! -w /tmp/file1 ]
[ $? -ne 0 ] && echo "文件可读且可写." || echo "文件不可读且不可写."

11、编写脚本/root/bin/nologin.sh和login.sh,实现禁止和充许普通用户登录系统。

[root@6 bin]# /root/bin/nologin.sh
禁止普通用户登录系统centos6
#! /bin/bash
#禁止普通用户登录系统
num=$(sed -nr 's/.*release\ ([0-9])..*/\1/p' /etc/centos-release)
[ $num -eq 6 ] &&  touch /etc/nologin && echo "禁止普通用户登录系统centos6"
[ $num -eq 7 ] &&  touch /run/nologin && echo "禁止普通用户登录系统centos7"
[root@6 bin]# /root/bin/login.sh
允许普通用户登录系统centos6
#! /bin/bash
#允许普通用户登录系统
num=$(sed -nr 's/.*release\ ([0-9])..*/\1/p' /etc/centos-release)
[ $num -eq 6 ] &&  rm -f /etc/nologin && echo "允许普通用户登录系统centos6"
[ $num -eq 7 ] &&  rm -f /run/nologin && echo "允许普通用户登录系统centos7"

12、写一个脚本/root/bin/hostping.sh,接受一个主机的IPv4地址做为参数,先判断是否合格IP,否,提示IP格式不合法并退出,是,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”;如果不可ping通,则提示用户“该IP地址不可访问”

[root@6 bin]# /root/bin/hostping.sh  255.255.255.255
此IP地址不合法.
[root@6 bin]# /root/bin/hostping.sh  10.1.252.180
该IP地址可访问.
[root@6 bin]# /root/bin/hostping.sh  10.1.252.167
该IP地址不可访问.
#! /bin/bash
#接受一个主机的IPv4地址做为参数,测试是否可连通。如果能ping通,则提示用户“该IP地址可访问”如果不可ping通,则提示用户“该IP地址不可访问”
echo $1 |egrep -o '(\b([1-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\b\.){3}\b([1-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-4])\b' &> /dev/null
[ $? -eq 0 ] && (ping -c1 -w1 $1 &> /dev/null && echo "该IP地址可访问."||echo "该IP地址不可访问.") || echo "此IP地址不合法."  && exit

13、计算1+2+3+…+100的值  sum1.sh

[root@6 bin]# /root/bin/sum.sh
1+2+3+...+100的值=5050
#! /bin/bash
#计算1+2+3+...+100的值
num=$(echo {1..100}|tr ' ' '+')
sum=$[$num]
echo "1+2+3+...+100的值=$sum"
unset num
unset sum

14、计算从脚本第一参数A开始,到第二个参数B的所有数字的总和,判断B是否大于A,否提示错误并退出,是则计算之  sun2.sh

[root@6 bin]# /root/bin/sum2.sh 1 2
两个参数的和=3
[root@6 bin]# /root/bin/sum2.sh 2 1
ERROR
#! /bin/bash
#计算从脚本第一参数A开始,到第二个参数B的所有数字的总和,判断B是否大于A,否提示错误并退出,是
则计算之
[ $2 -lt  $1 ]
[ $? -eq  0 ]&& sum=$[$1+$2] && echo "两个参数的和=$sum" || echo "ERROR" && exit

原创文章,作者:lvasu,如若转载,请注明出处:http://www.178linux.com/34319

评论列表(1条)

  • 马哥教育
    马哥教育 2016-08-15 17:30

    总结的很详细,再接再厉

联系我们

400-080-6560

在线咨询

工作时间:周一至周五,9:30-18:30,节假日同时也值班

QR code